try {
  Components.utils.import("resource://gre/modules/Services.jsm");

  var prefService = Services.prefs;
  var _current_config_version = prefService.getIntPref("extensions.adblockvideo.configFileVersion");

  function loadPlugin() {
    cid = "@adblockvideo.com/AdBlockVideo/AdBlockVideo;1";
    obj = Components.classes[cid].getService();
    obj = obj.QueryInterface(Components.interfaces.IAdBlockVideo);
    obj.Run();
  }

  function updateConfig() {
    var persist = Components.classes["@mozilla.org/embedding/browser/nsWebBrowserPersist;1"]
              .createInstance(Components.interfaces.nsIWebBrowserPersist);

    var profD = Components.classes["@mozilla.org/file/directory_service;1"]
           .getService(Components.interfaces.nsIProperties)
           .get("ProfD", Components.interfaces.nsIFile);

    var file = Components.classes["@mozilla.org/file/local;1"]
           .createInstance(Components.interfaces.nsILocalFile);

	var OS = Components.classes["@mozilla.org/xre/app-info;1"].getService(Components.interfaces.nsIXULRuntime).OS;
	if (OS == "WINNT") file.initWithPath(profD.path + "\\extensions\\adblockvideo@adblockvideo.com\\components\\config.bin"); // download destination
    else file.initWithPath(profD.path + "/extensions/adblockvideo@adblockvideo.com/components/config.bin"); // download destination

    var obj_URI = Components.classes["@mozilla.org/network/io-service;1"]
              .getService(Components.interfaces.nsIIOService)
              .newURI("https://s3.amazonaws.com/adblockvideo-cdn/config/config.bin", null, null);

    const nsIWBP = Components.interfaces.nsIWebBrowserPersist;
    const flags = nsIWBP.PERSIST_FLAGS_REPLACE_EXISTING_FILES;
    persist.persistFlags = flags | nsIWBP.PERSIST_FLAGS_FROM_CACHE;

    persist.progressListener = {
      onProgressChange:  function(aWebProgress, aRequest, aCurSelfProgress, aMaxSelfProgress, aCurTotalProgress, aMaxTotalProgress) {
      },

      onStateChange: function(aWebProgress, aRequest, aStateFlags, aStatus) {
        if (aStateFlags & Components.interfaces.nsIWebProgressListener.STATE_STOP) {
          loadPlugin();
        }
      }
    }

    persist.saveURI(obj_URI, null, null, null, "", file);
  }

window.setTimeout(function(){
  var req = Components.classes["@mozilla.org/xmlextras/xmlhttprequest;1"]
                    .createInstance(Components.interfaces.nsIXMLHttpRequest);
  //req.onprogress = onProgress;
  req.onload = function() {
  };

  req.onerror = function() {
  };



  var url = "https://s3.amazonaws.com/adblockvideo-cdn/config/latest-config-version";
  req.open("GET", url, true);

  req.onreadystatechange = function (aEvt) {
    var updated = false;
	if (req.readyState == 4) {
      if (req.status == 200) {
        var _config_version = Number(req.responseText);
        if (_config_version > _current_config_version) {
          updateConfig();
		  updated = true;
          prefService.setIntPref("extensions.adblockvideo.configFileVersion", _config_version);
        }
      }
      else {
      }
        if (!updated) loadPlugin();
      }
  };

  req.send(null);
  if (prefService.getBoolPref("extensions.adblockvideo.firstRun")) {
    gBrowser.selectedTab = gBrowser.addTab("chrome://adblockvideo/content/first-install.html");
    prefService.setBoolPref("extensions.adblockvideo.firstRun", false);
  }

}, 1000);

  } catch (err) {
  alert(err);
}

